/*

UAV Ground Station model aircraft wing design tool
Copyright (C) 2003 Robin Stanton

This file is part of UAV Ground Station.

UAV Ground Station is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

UAV Ground Station is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with UAV Ground Station; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
/*
file.cpp

  File i/o.
*/

#include <stdio.h>
#include <windows.h>
#pragma hdrstop
#define _FILE_CPP_
#include "file.h"

int ReadLine(CFileR *f, char *str)
{
	int p;
	char c;
	
	*str = 0;
	p = 0;
	
	if (!f->read(&c, 1)) return 0;
	if ((c != 10) && (c != 13))
	{
		str[p] = c;
		p++;
		str[p] = 0;
	}
	if (!f->read(&c, 1)) return 0;

	while ((c != 10) && (c != 13))
	{
		str[p] = c;
		p++;
		str[p] = 0;

		if (!f->read(&c, 1)) return 0;
	}
	return 1;
}

/*
CFileW
*/

CFileW::CFileW()
{
	hFile = INVALID_HANDLE_VALUE;
}
CFileW::CFileW(char *name)
{
	open(name);
}
CFileW::~CFileW()
{
	close();
}
int CFileW::open(char *name)
{
	hFile = CreateFile(name, GENERIC_WRITE, FILE_SHARE_READ, 0,
	                   CREATE_ALWAYS, 0, 0);	

	if (hFile == INVALID_HANDLE_VALUE)
		return 0;
	else
		return 1;
}
void CFileW::close()
{
	if (hFile != INVALID_HANDLE_VALUE)
		CloseHandle(hFile);
	hFile = INVALID_HANDLE_VALUE;
}
int CFileW::write(void *data, int size)
{
	BOOL result;
	DWORD written;

	result = WriteFile(hFile, data, size, &written, 0);
	if (!result || (written != (unsigned) size))
		return 0;
	else
		return 1;
}

/*
CFileR
*/

CFileR::CFileR()
{
	hFile = INVALID_HANDLE_VALUE;
}
CFileR::CFileR(char *name)
{
	open(name);
}
CFileR::~CFileR()
{
	close();
}
int CFileR::open(char *name)
{
	hFile = CreateFile(name, GENERIC_READ, FILE_SHARE_READ, 0,
	                   OPEN_EXISTING, 0, 0);	

	if (hFile == INVALID_HANDLE_VALUE)
		return 0;
	else
		return 1;
}
void CFileR::close()
{
	if (hFile != INVALID_HANDLE_VALUE)
		CloseHandle(hFile);
	hFile = INVALID_HANDLE_VALUE;
}
int CFileR::read(void *data, int size)
{
	BOOL result;
	DWORD nread;

	result = ReadFile(hFile, data, size, &nread, 0);
	if (!result || (nread != (unsigned) size))
		return 0;
	else
		return 1;
	return 1;
}
