/*

UAV Ground Station model aircraft wing design tool
Copyright (C) 2003 Robin Stanton

This file is part of UAV Ground Station.

UAV Ground Station is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

UAV Ground Station is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with UAV Ground Station; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#ifndef _UAVGS_H_
#define _UAVGS_H_

#ifndef _UAVGS_CPP_
#define _UAVGS_CPP_ extern
#endif

#include "strings.h"
#include "script.h"
#include "wndlayout.h"

_UAVGS_CPP_ CWndLayout wndLayout;
_UAVGS_CPP_ HWND hWnd1, hWndMsg, hWndFrame, hWndStatus;
_UAVGS_CPP_ HINSTANCE hInstance;

_UAVGS_CPP_ HFONT hfDefault;

_UAVGS_CPP_ HBITMAP hbmpWndBkg;
_UAVGS_CPP_ bool isTransparent;

_UAVGS_CPP_ bool fullscreen;

// Transparent background colour keys
#define BKGC_BLACK	0
#define BKGC_BLUE	1
#define BKGC_GREEN	2

_UAVGS_CPP_ HBRUSH hbrWndBkg, hbrGaugeBkg;
_UAVGS_CPP_ HBRUSH hbrBkgGrey, hbrBkgBlue, hbrBkgGreen, hbrBkgBlack;
_UAVGS_CPP_ int bkgColorKey;	// BKGC_*
_UAVGS_CPP_ bool gaugeTransparent;

_UAVGS_CPP_ bool gaugeFlash;

// Background images
#define BKG_NONE	1
#define BKG_LOGO	2
#define BKG_METAL	3
#define BKG_GRID	4
_UAVGS_CPP_ int bkgImage;	// BKG_*

_UAVGS_CPP_ char uavFilename[1024], mapFilename[1024];

void message(char *msgin);
void error(char *msg);
void fatalError(char *msg);

void setTransparent(bool tr);
void setWindowBkg(HBRUSH hbr);
void setGaugeBkg(HBRUSH hbr);
void setFullscreen(bool fs);

void LoadSettings(int recursing = 0);
void SaveSettings();
void setBkgImage(int img);

#endif
