/*

UAV Ground Station model aircraft wing design tool
Copyright (C) 2003 Robin Stanton

This file is part of UAV Ground Station.

UAV Ground Station is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

UAV Ground Station is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with UAV Ground Station; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
/*
uavtime.cpp

  UAV mission time.
*/

#include <stdio.h>
#include <windows.h>
#include <commctrl.h>
#pragma hdrstop
#define _UAVTIME_CPP_
#include "uavtime.h"
#include "uavgs.h"

DWORD missionStart;
int timeValid = 0;

void timerReset()
{
	char str[256], time[64], old[64];
	SYSTEMTIME st;

	timerGet(old);

	missionStart = GetTickCount();
	GetLocalTime(&st);
	GetTimeFormat(LOCALE_USER_DEFAULT, 0, &st, 0, time, 63);

	if (timeValid)
	{
		sprintf(str, "!Clock reset at %s (was %s)", time, old);
	} else
		sprintf(str, "!Clock reset at %s", time);

	timeValid = 1;
	
	message(str);
}

int timerGet(char *str)
{
	int time;
	int h, m, s;

	if (timeValid)
	{
		time = int(GetTickCount() - missionStart) / 1000;
		s = time % 60;
		m = (time / 60) % 60;
		h = time / 3600;

		sprintf(str, "%02i:%02i:%02i", h, m, s);
	} else
		strcpy(str, "??:??:??");

	return timeValid;
}
